/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the TokenTrait type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &TokenTrait{}

// TokenTrait struct for TokenTrait
type TokenTrait struct {
	Token *string `json:"token,omitempty"`
}

// NewTokenTrait instantiates a new TokenTrait object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewTokenTrait() *TokenTrait {
	this := TokenTrait{}
	return &this
}

// NewTokenTraitWithDefaults instantiates a new TokenTrait object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewTokenTraitWithDefaults() *TokenTrait {
	this := TokenTrait{}
	return &this
}

// GetToken returns the Token field value if set, zero value otherwise.
func (o *TokenTrait) GetToken() string {
	if o == nil || IsNil(o.Token) {
		var ret string
		return ret
	}
	return *o.Token
}

// GetTokenOk returns a tuple with the Token field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TokenTrait) GetTokenOk() (*string, bool) {
	if o == nil || IsNil(o.Token) {
		return nil, false
	}
	return o.Token, true
}

// HasToken returns a boolean if a field has been set.
func (o *TokenTrait) HasToken() bool {
	if o != nil && !IsNil(o.Token) {
		return true
	}

	return false
}

// SetToken gets a reference to the given string and assigns it to the Token field.
func (o *TokenTrait) SetToken(v string) {
	o.Token = &v
}

func (o TokenTrait) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o TokenTrait) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Token) {
		toSerialize["token"] = o.Token
	}
	return toSerialize, nil
}

type NullableTokenTrait struct {
	value *TokenTrait
	isSet bool
}

func (v NullableTokenTrait) Get() *TokenTrait {
	return v.value
}

func (v *NullableTokenTrait) Set(val *TokenTrait) {
	v.value = val
	v.isSet = true
}

func (v NullableTokenTrait) IsSet() bool {
	return v.isSet
}

func (v *NullableTokenTrait) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableTokenTrait(val *TokenTrait) *NullableTokenTrait {
	return &NullableTokenTrait{value: val, isSet: true}
}

func (v NullableTokenTrait) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableTokenTrait) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
